Attribute VB_Name = "mdlJoystick"
Option Explicit

'These code is for work with Joystick

Public Declare Function joyGetPosEx Lib "winmm.dll" (ByVal uJoyID As Long, pji As JOYINFOEX) As Long
Public Declare Function joyGetDevCapsA Lib "winmm.dll" (ByVal uJoyID As Long, pjc As JOYCAPS, ByVal cjc As Long) As Long

Public Type JOYCAPS
    wMid As Integer
    wPid As Integer
    szPname As String * 32
    wXmin As Long
    wXmax As Long
    wYmin As Long
    wYmax As Long
    wZmin As Long
    wZmax As Long
    wNumButtons As Long
    wPeriodMin As Long
    wPeriodMax As Long
    wRmin As Long
    wRmax As Long
    wUmin As Long
    wUmax As Long
    wVmin As Long
    wVmax As Long
    wCaps As Long
    wMaxAxes As Long
    wNumAxes As Long
    wMaxButtons As Long
    szRegKey As String * 32
    szOEMVxD As String * 260
End Type

Public Type JOYINFOEX
    dwSize As Long
    dwFlags As Long
    dwXpos As Long
    dwYpos As Long
    dwZpos As Long
    dwRpos As Long
    dwUpos As Long
    dwVpos As Long
    dwButtons As Long
    dwButtonNumber As Long
    dwPOV As Long
    dwReserved1 As Long
    dwReserved2 As Long
End Type

Public JoyNum As Long
Public MYJOYEX As JOYINFOEX
Public MYJOYCAPS As JOYCAPS
Public lngButton As Long

Public Function StartJoystick(Optional ByVal JoystickNumber As Long = 0) As Boolean
    JoyNum = JoystickNumber
    If joyGetDevCapsA(JoyNum, MYJOYCAPS, 404) <> 0 Then 'Get joystick info
        StartJoystick = False
    Else
        MYJOYEX.dwSize = 64
        MYJOYEX.dwFlags = 255
        Call joyGetPosEx(JoyNum, MYJOYEX)
        StartJoystick = True
    End If
End Function

Public Sub PollJoystick()
    
    MYJOYEX.dwSize = 64
    MYJOYEX.dwFlags = 255

    ' Get the joystick information
    Call joyGetPosEx(JoyNum, MYJOYEX)
    lngButton = MYJOYEX.dwButtons
    If lngButton <> 0 Then lngButton = (Log(lngButton) / Log(2)) + 1
End Sub
